;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: CLK_ADC_DT.asm
;;   Version: 2.6, Updated on 2008/9/17 at 16:15:44
;;  Generated by PSoC Designer ???
;;
;;  DESCRIPTION: Timer8 User Module software implementation file
;;               for the 22/24/27/29xxx PSoC family of devices
;;
;;  NOTE: User Module APIs conform to the fastcall16 convention for marshalling
;;        arguments and observe the associated "Registers are volatile" policy.
;;        This means it is the caller's responsibility to preserve any values
;;        in the X and A registers that are still needed after the API functions
;;        returns. For Large Memory Model devices it is also the caller's 
;;        responsibility to perserve any value in the CUR_PP, IDX_PP, MVR_PP and 
;;        MVW_PP registers. Even though some of these registers may not be modified
;;        now, there is no guarantee that will remain the case in future releases.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "CLK_ADC_DT.inc"

;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export  CLK_ADC_DT_EnableInt
export _CLK_ADC_DT_EnableInt
export  CLK_ADC_DT_DisableInt
export _CLK_ADC_DT_DisableInt
export  CLK_ADC_DT_Start
export _CLK_ADC_DT_Start
export  CLK_ADC_DT_Stop
export _CLK_ADC_DT_Stop
export  CLK_ADC_DT_WritePeriod
export _CLK_ADC_DT_WritePeriod
export  CLK_ADC_DT_WriteCompareValue
export _CLK_ADC_DT_WriteCompareValue
export  CLK_ADC_DT_bReadCompareValue
export _CLK_ADC_DT_bReadCompareValue
export  CLK_ADC_DT_bReadTimer
export _CLK_ADC_DT_bReadTimer
export  CLK_ADC_DT_bReadTimerSaveCV
export _CLK_ADC_DT_bReadTimerSaveCV

; The following functions are deprecated and subject to omission in future releases
;
export  bCLK_ADC_DT_ReadCompareValue  ; deprecated
export _bCLK_ADC_DT_ReadCompareValue  ; deprecated
export  bCLK_ADC_DT_ReadTimer         ; deprecated
export _bCLK_ADC_DT_ReadTimer         ; deprecated
export  bCLK_ADC_DT_ReadTimerSaveCV   ; deprecated
export _bCLK_ADC_DT_ReadTimerSaveCV   ; deprecated

export  bCLK_ADC_DT_ReadCounter       ; obsolete
export _bCLK_ADC_DT_ReadCounter       ; obsolete
export  bCLK_ADC_DT_CaptureCounter    ; obsolete
export _bCLK_ADC_DT_CaptureCounter    ; obsolete


AREA morse_RAM (RAM,REL)

;-----------------------------------------------
;  Constant Definitions
;-----------------------------------------------


;-----------------------------------------------
; Variable Allocation
;-----------------------------------------------


AREA UserModules (ROM, REL)

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CLK_ADC_DT_EnableInt
;
;  DESCRIPTION:
;     Enables this timer's interrupt by setting the interrupt enable mask bit
;     associated with this User Module. This function has no effect until and
;     unless the global interrupts are enabled (for example by using the
;     macro M8C_EnableGInt).
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      Nothing.
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 CLK_ADC_DT_EnableInt:
_CLK_ADC_DT_EnableInt:
   RAM_PROLOGUE RAM_USE_CLASS_1
   CLK_ADC_DT_EnableInt_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CLK_ADC_DT_DisableInt
;
;  DESCRIPTION:
;     Disables this timer's interrupt by clearing the interrupt enable
;     mask bit associated with this User Module.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 CLK_ADC_DT_DisableInt:
_CLK_ADC_DT_DisableInt:
   RAM_PROLOGUE RAM_USE_CLASS_1
   CLK_ADC_DT_DisableInt_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CLK_ADC_DT_Start
;
;  DESCRIPTION:
;     Sets the start bit in the Control register of this user module.  The
;     timer will begin counting on the next input clock.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 CLK_ADC_DT_Start:
_CLK_ADC_DT_Start:
   RAM_PROLOGUE RAM_USE_CLASS_1
   CLK_ADC_DT_Start_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CLK_ADC_DT_Stop
;
;  DESCRIPTION:
;     Disables timer operation by clearing the start bit in the Control
;     register.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 CLK_ADC_DT_Stop:
_CLK_ADC_DT_Stop:
   RAM_PROLOGUE RAM_USE_CLASS_1
   CLK_ADC_DT_Stop_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CLK_ADC_DT_WritePeriod
;
;  DESCRIPTION:
;     Write the 8-bit period value into the Period register (DR1). If the
;     Timer user module is stopped, then this value will also be latched
;     into the Count register (DR0).
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: fastcall16 BYTE bPeriodValue (passed in A)
;  RETURNS:   Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 CLK_ADC_DT_WritePeriod:
_CLK_ADC_DT_WritePeriod:
   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   reg[CLK_ADC_DT_PERIOD_REG], A
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CLK_ADC_DT_WriteCompareValue
;
;  DESCRIPTION:
;     Writes compare value into the Compare register (DR2).
;
;     NOTE! The Timer user module must be STOPPED in order to write the
;           Compare register. (Call CLK_ADC_DT_Stop to disable).
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    fastcall16 BYTE bCompareValue (passed in A)
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 CLK_ADC_DT_WriteCompareValue:
_CLK_ADC_DT_WriteCompareValue:
   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   reg[CLK_ADC_DT_COMPARE_REG], A
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CLK_ADC_DT_bReadCompareValue
;
;  DESCRIPTION:
;     Reads the Compare register.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      fastcall16 BYTE bCompareValue (value of DR2 in the A register)
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 CLK_ADC_DT_bReadCompareValue:
_CLK_ADC_DT_bReadCompareValue:
 bCLK_ADC_DT_ReadCompareValue:                   ; this name deprecated
_bCLK_ADC_DT_ReadCompareValue:                   ; this name deprecated
   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   A, reg[CLK_ADC_DT_COMPARE_REG]
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CLK_ADC_DT_bReadTimerSaveCV
;
;  DESCRIPTION:
;     Returns the value in the Count register (DR0), preserving the
;     value in the compare register (DR2).
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: None
;  RETURNS:   fastcall16 BYTE bCount (value of DR0 in the A register)
;  SIDE EFFECTS:
;     1) May cause an interrupt, if interrupt on Compare is enabled.
;     2) If enabled, Global interrupts are momentarily disabled.
;     3) The user module is stopped momentarily while the compare value is
;        restored.  This may cause the Count register to miss one or more
;        counts depending on the input clock speed.
;     4) The A and X registers may be modified by this or future implementations
;        of this function.  The same is true for all RAM page pointer registers in
;        the Large Memory Model.  When necessary, it is the calling function's
;        responsibility to perserve their values across calls to fastcall16 
;        functions.
;
;  THEORY of OPERATION:
;     1) Read and save the Compare register.
;     2) Read the Count register, causing its data to be latched into
;        the Compare register.
;     3) Read and save the Counter value, now in the Compare register,
;        to the buffer.
;     4) Disable global interrupts
;     5) Halt the timer
;     6) Restore the Compare register values
;     7) Start the Timer again
;     8) Restore global interrupt state
;
 CLK_ADC_DT_bReadTimerSaveCV:
_CLK_ADC_DT_bReadTimerSaveCV:
 bCLK_ADC_DT_ReadTimerSaveCV:                    ; this name deprecated
_bCLK_ADC_DT_ReadTimerSaveCV:                    ; this name deprecated
 bCLK_ADC_DT_ReadCounter:                        ; this name deprecated
_bCLK_ADC_DT_ReadCounter:                        ; this name deprecated

CpuFlags:      equ   0
bCount:        equ   1

   RAM_PROLOGUE RAM_USE_CLASS_2
   mov   X, SP                                   ; X <- stack frame pointer
   add   SP, 2                                   ; Reserve space for flags, count
   mov   A, reg[CLK_ADC_DT_CONTROL_REG]          ; save the Control register
   push  A
   mov   A, reg[CLK_ADC_DT_COMPARE_REG]          ; save the Compare register
   push  A
   mov   A, reg[CLK_ADC_DT_COUNTER_REG]          ; synchronous copy DR2 <- DR0
                                                 ; This may cause an interrupt!
   mov   A, reg[CLK_ADC_DT_COMPARE_REG]          ; Now grab DR2 (DR0) and save
   mov   [X+bCount], A
   mov   A, 0                                    ; Guess the global interrupt state
   tst   reg[CPU_F], FLAG_GLOBAL_IE              ; Currently Disabled?
   jz    .SetupStatusFlag                        ;   Yes, guess was correct
   mov   A, FLAG_GLOBAL_IE                       ;    No, modify our guess
.SetupStatusFlag:                                ; and ...
   mov   [X+CpuFlags], A                         ;   StackFrame[0] <- Flag Reg image
   M8C_DisableGInt                               ; Disable interrupts globally
   CLK_ADC_DT_Stop_M                             ; Stop the timer
   pop   A                                       ; Restore the Compare register
   mov   reg[CLK_ADC_DT_COMPARE_REG], A
   pop   A                                       ; restore start state of the timer
   mov   reg[CLK_ADC_DT_CONTROL_REG], A
   pop   A                                       ; Return result stored in stack frame
   RAM_EPILOGUE RAM_USE_CLASS_2
   reti                                          ; Flag Reg <- StackFrame[0]

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CLK_ADC_DT_bReadTimer
;
;  DESCRIPTION:
;     Performs a software capture of the Count register.  A synchronous
;     read of the Count register is performed.  The timer is NOT stopped.
;
;     WARNING - this will cause loss of data in the Compare register.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      fastcall16 BYTE bCount, (value of DR0 in the A register)
;  SIDE EFFECTS:
;    May cause an interrupt.
;
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
;  THEORY of OPERATION:
;     1) Read the Count register - this causes the count value to be
;        latched into the Compare register.
;     2) Read and return the Count register values from the Compare
;        registers into the return buffer.
;
 CLK_ADC_DT_bReadTimer:
_CLK_ADC_DT_bReadTimer:
 bCLK_ADC_DT_ReadTimer:                          ; this name deprecated
_bCLK_ADC_DT_ReadTimer:                          ; this name deprecated
 bCLK_ADC_DT_CaptureCounter:                     ; this name deprecated
_bCLK_ADC_DT_CaptureCounter:                     ; this name deprecated

   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   A, reg[CLK_ADC_DT_COUNTER_REG]          ; synchronous copy DR2 <- DR0
                                                 ; This may cause an interrupt!
   mov   A, reg[CLK_ADC_DT_COMPARE_REG]          ; Return DR2 (actually DR0)
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION

; End of File CLK_ADC_DT.asm
