;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: CLK_ADC_DT.inc
;;   Version: 2.6, Updated on 2008/9/17 at 16:15:44
;;  Generated by PSoC Designer ???
;;
;;  DESCRIPTION: Assembler declarations for the Timer8 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for CLK_ADC_DT API's.
;--------------------------------------------------

CLK_ADC_DT_CONTROL_REG_START_BIT:          equ 0x01    ; Control register start bit
CLK_ADC_DT_INT_REG:                        equ 0x0e1
CLK_ADC_DT_INT_MASK:                       equ 0x02


;--------------------------------------------------
; Constants for CLK_ADC_DT user defined values
;--------------------------------------------------

CLK_ADC_DT_PERIOD:                         equ 0x1d
CLK_ADC_DT_COMPARE_VALUE:                  equ 0x0e


;--------------------------------------------------
; Register Address Constants for CLK_ADC_DT
;--------------------------------------------------

CLK_ADC_DT_COUNTER_REG:                equ 0x24   ; DR0 Counter register
CLK_ADC_DT_PERIOD_REG:                 equ 0x25   ; DR1 Period register
CLK_ADC_DT_COMPARE_REG:                equ 0x26   ; DR2 CompareValue register
CLK_ADC_DT_CONTROL_REG:                equ 0x27   ; Control register
CLK_ADC_DT_FUNC_REG:                   equ 0x24   ; Function register
CLK_ADC_DT_INPUT_REG:                  equ 0x25   ; Input register
CLK_ADC_DT_OUTPUT_REG:                 equ 0x26   ; Output register


;--------------------------------------------------
; CLK_ADC_DT Macro 'Functions'
;--------------------------------------------------

   macro CLK_ADC_DT_Start_M
   or    reg[CLK_ADC_DT_CONTROL_REG],  CLK_ADC_DT_CONTROL_REG_START_BIT
   endm

   macro CLK_ADC_DT_Stop_M
   and   reg[CLK_ADC_DT_CONTROL_REG], ~CLK_ADC_DT_CONTROL_REG_START_BIT
   endm

   macro CLK_ADC_DT_EnableInt_M
   M8C_EnableIntMask CLK_ADC_DT_INT_REG, CLK_ADC_DT_INT_MASK
   endm

   macro CLK_ADC_DT_DisableInt_M
   M8C_DisableIntMask CLK_ADC_DT_INT_REG, CLK_ADC_DT_INT_MASK
   endm


; end of file CLK_ADC_DT.inc
