//*****************************************************************************
//*****************************************************************************
//  FILENAME: CLK_ADC_DT.h
//   Version: 2.6, Updated on 2008/9/17 at 16:15:44
//  Generated by PSoC Designer ???
//
//  DESCRIPTION: Timer8 User Module C Language interface file
//               for the 22/24/27/29xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 CLK_ADC_DT_EnableInt                 //                 Proxy 1
#pragma fastcall16 CLK_ADC_DT_DisableInt                //                 Proxy 1
#pragma fastcall16 CLK_ADC_DT_Start                     //                 Proxy 1
#pragma fastcall16 CLK_ADC_DT_Stop                      //                 Proxy 1
#pragma fastcall16 CLK_ADC_DT_bReadTimer                // Read  DR0       Proxy 1
#pragma fastcall16 CLK_ADC_DT_bReadTimerSaveCV          // Read  DR0       Proxy 2
#pragma fastcall16 CLK_ADC_DT_WritePeriod               // Write DR1       Proxy 1
#pragma fastcall16 CLK_ADC_DT_bReadCompareValue         // Read  DR2       Proxy 1
#pragma fastcall16 CLK_ADC_DT_WriteCompareValue         // Write DR2       Proxy 1

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 bCLK_ADC_DT_ReadCounter              // Read  DR0 "Obsolete"
#pragma fastcall16 bCLK_ADC_DT_CaptureCounter           // Read  DR0 "Obsolete"
#pragma fastcall16 bCLK_ADC_DT_ReadTimer                // Read  DR0 (Deprecated)
#pragma fastcall16 bCLK_ADC_DT_ReadTimerSaveCV          // Read  DR0 (Deprecated)
#pragma fastcall16 bCLK_ADC_DT_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the CLK_ADC_DT API.
//-------------------------------------------------

extern void CLK_ADC_DT_EnableInt(void);
extern void CLK_ADC_DT_DisableInt(void);
extern void CLK_ADC_DT_Start(void);
extern void CLK_ADC_DT_Stop(void);
extern BYTE CLK_ADC_DT_bReadTimer(void);
extern BYTE CLK_ADC_DT_bReadTimerSaveCV(void);
extern void CLK_ADC_DT_WritePeriod(BYTE bPeriod);
extern BYTE CLK_ADC_DT_bReadCompareValue(void);
extern void CLK_ADC_DT_WriteCompareValue(BYTE bCompareValue);

// The following functions are deprecated.
// They may be omitted in future releases
//
extern BYTE bCLK_ADC_DT_ReadCompareValue(void);       // Deprecated
extern BYTE bCLK_ADC_DT_ReadTimerSaveCV(void);        // Deprecated
extern BYTE bCLK_ADC_DT_ReadCounter(void);            // Obsolete
extern BYTE bCLK_ADC_DT_ReadTimer(void);              // Deprecated
extern BYTE bCLK_ADC_DT_CaptureCounter(void);         // Obsolete


//--------------------------------------------------
// Constants for CLK_ADC_DT API's.
//--------------------------------------------------

#define CLK_ADC_DT_CONTROL_REG_START_BIT       ( 0x01 )
#define CLK_ADC_DT_INT_REG_ADDR                ( 0x0e1 )
#define CLK_ADC_DT_INT_MASK                    ( 0x02 )


//--------------------------------------------------
// Constants for CLK_ADC_DT user defined values
//--------------------------------------------------

#define CLK_ADC_DT_PERIOD                      ( 0x1d )
#define CLK_ADC_DT_COMPARE_VALUE               ( 0x0e )


//-------------------------------------------------
// Register Addresses for CLK_ADC_DT
//-------------------------------------------------

#pragma ioport  CLK_ADC_DT_COUNTER_REG: 0x024              //DR0 Count register
BYTE            CLK_ADC_DT_COUNTER_REG;
#pragma ioport  CLK_ADC_DT_PERIOD_REG:  0x025              //DR1 Period register
BYTE            CLK_ADC_DT_PERIOD_REG;
#pragma ioport  CLK_ADC_DT_COMPARE_REG: 0x026              //DR2 Compare register
BYTE            CLK_ADC_DT_COMPARE_REG;
#pragma ioport  CLK_ADC_DT_CONTROL_REG: 0x027              //Control register
BYTE            CLK_ADC_DT_CONTROL_REG;
#pragma ioport  CLK_ADC_DT_FUNC_REG:    0x124              //Function register
BYTE            CLK_ADC_DT_FUNC_REG;
#pragma ioport  CLK_ADC_DT_INPUT_REG:   0x125              //Input register
BYTE            CLK_ADC_DT_INPUT_REG;
#pragma ioport  CLK_ADC_DT_OUTPUT_REG:  0x126              //Output register
BYTE            CLK_ADC_DT_OUTPUT_REG;
#pragma ioport  CLK_ADC_DT_INT_REG:       0x0e1            //Interrupt Mask Register
BYTE            CLK_ADC_DT_INT_REG;


//-------------------------------------------------
// CLK_ADC_DT Macro 'Functions'
//-------------------------------------------------

#define CLK_ADC_DT_Start_M \
   ( CLK_ADC_DT_CONTROL_REG |=  CLK_ADC_DT_CONTROL_REG_START_BIT )

#define CLK_ADC_DT_Stop_M  \
   ( CLK_ADC_DT_CONTROL_REG &= ~CLK_ADC_DT_CONTROL_REG_START_BIT )

#define CLK_ADC_DT_EnableInt_M   \
   M8C_EnableIntMask(  CLK_ADC_DT_INT_REG, CLK_ADC_DT_INT_MASK )

#define CLK_ADC_DT_DisableInt_M  \
   M8C_DisableIntMask( CLK_ADC_DT_INT_REG, CLK_ADC_DT_INT_MASK )


// end of file CLK_ADC_DT.h
