;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: CLK_BPF_DT.inc
;;   Version: 2.6, Updated on 2008/9/17 at 16:15:44
;;  Generated by PSoC Designer ???
;;
;;  DESCRIPTION: Assembler declarations for the Timer8 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for CLK_BPF_DT API's.
;--------------------------------------------------

CLK_BPF_DT_CONTROL_REG_START_BIT:          equ 0x01    ; Control register start bit
CLK_BPF_DT_INT_REG:                        equ 0x0e1
CLK_BPF_DT_INT_MASK:                       equ 0x01


;--------------------------------------------------
; Constants for CLK_BPF_DT user defined values
;--------------------------------------------------

CLK_BPF_DT_PERIOD:                         equ 0x44
CLK_BPF_DT_COMPARE_VALUE:                  equ 0x22


;--------------------------------------------------
; Register Address Constants for CLK_BPF_DT
;--------------------------------------------------

CLK_BPF_DT_COUNTER_REG:                equ 0x20   ; DR0 Counter register
CLK_BPF_DT_PERIOD_REG:                 equ 0x21   ; DR1 Period register
CLK_BPF_DT_COMPARE_REG:                equ 0x22   ; DR2 CompareValue register
CLK_BPF_DT_CONTROL_REG:                equ 0x23   ; Control register
CLK_BPF_DT_FUNC_REG:                   equ 0x20   ; Function register
CLK_BPF_DT_INPUT_REG:                  equ 0x21   ; Input register
CLK_BPF_DT_OUTPUT_REG:                 equ 0x22   ; Output register


;--------------------------------------------------
; CLK_BPF_DT Macro 'Functions'
;--------------------------------------------------

   macro CLK_BPF_DT_Start_M
   or    reg[CLK_BPF_DT_CONTROL_REG],  CLK_BPF_DT_CONTROL_REG_START_BIT
   endm

   macro CLK_BPF_DT_Stop_M
   and   reg[CLK_BPF_DT_CONTROL_REG], ~CLK_BPF_DT_CONTROL_REG_START_BIT
   endm

   macro CLK_BPF_DT_EnableInt_M
   M8C_EnableIntMask CLK_BPF_DT_INT_REG, CLK_BPF_DT_INT_MASK
   endm

   macro CLK_BPF_DT_DisableInt_M
   M8C_DisableIntMask CLK_BPF_DT_INT_REG, CLK_BPF_DT_INT_MASK
   endm


; end of file CLK_BPF_DT.inc
