//---------------------------
// Title:	Morsedecoder
// Device:	CY8C27443-24PXI

// based on Cypress Application Note AN2124
// migrated to new PSoc CY8C27443-24PXI device
//
// applied Audiosignal (P0.1) will be filtered, processed and output (P0.5).
// morse decoded characters will be displayed on a std.2x16 LCD 
// see original Cypress AN2124 for schematics and documentation
// INPUT:		1Vss to 2Vss @ 800Hz ( tone lock frequency )
//
// Authors:		Markus Hoelzl - DG5MdB aka ASCII
//				Oliver Gebele - DG2OG
// Version: 	1.0
// Date:		09.12.2008
// Tools:		PsoC-Designer 5, miniProg1, CY3210miniEval
//
//---------------------------
#include <m8c.h>
#include "PSoCAPI.h"

extern char Counter5ms;
extern void DisplaySetup(void);
extern void DisplayWelcomeMessage(void);
extern void TONEDET_Setup(void);
extern void MorseDecoder(void);

void main()
{
	M8C_EnableGInt;

    DisplaySetup();
	TONEDET_Setup();

	//DataConfigStart
	PGA_INP_DT_Start(PGA_INP_DT_HIGHPOWER);
	PGA_ADC_DT_Start(PGA_ADC_DT_HIGHPOWER);
	AGND_DT_Start(AGND_DT_HIGHPOWER);
   	BPF_DT_1_Start(BPF_DT_1_HIGHPOWER);
	BPF_DT_2_Start(BPF_DT_2_HIGHPOWER);
	// CLK_BPF_DT_EnableInt();
	CLK_BPF_DT_Start();
	CLK_ADC_DT_Start();
	DELSIG8_Start(DELSIG8_HIGHPOWER);
	DELSIG8_StartAD();
	
	DisplayWelcomeMessage();
	
	Counter5ms=0;
	while (Counter5ms<250);
	//CLK_ADC_DT_WritePeriod(29);
	
	MorseDecoder();
	
	while(1);
}
